/**
 * ED.java
 *
 * File generated from the medication::ED uml Class
 * Generated by IHE - europe, gazelle team
 */
package net.ihe.gazelle.medication;

// End of user code
import java.util.List;

import javax.xml.bind.JAXBContext;
import javax.xml.bind.JAXBException;
import javax.xml.bind.Marshaller;
import javax.xml.bind.annotation.XmlAccessType;
import javax.xml.bind.annotation.XmlAccessorType;
import javax.xml.bind.annotation.XmlAttribute;
import javax.xml.bind.annotation.XmlRootElement;
import javax.xml.bind.annotation.XmlTransient;
import javax.xml.bind.annotation.XmlType;
import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.ParserConfigurationException;

import org.w3c.dom.Document;
import org.w3c.dom.Node;

import net.ihe.gazelle.gen.common.ConstraintValidatorModule;


/**
 * Description of the class ED.
 *
 * 
 */

@XmlAccessorType(XmlAccessType.FIELD)
@XmlType(name = "ED", propOrder = {
	"compression",
	"integrityCheck",
	"integrityCheckAlgorithm",
	"language",
	"mediaType"
})
@XmlRootElement(name = "desc")
public class ED extends net.ihe.gazelle.medication.BIN1 implements java.io.Serializable {
	
	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;

	
	/**
	 *                       Indicates whether the raw byte data
	                            is compressed,                      and what compression algorithm was
	                            used.                   .
	 */
	@XmlAttribute(name = "compression")
	public net.ihe.gazelle.medication.CompressionAlgorithm compression;
	/**
	 *                       The integrity check is a short
	                            binary value representing                      a cryptographically
	                            strong checksum that is calculated                      over the binary
	                            data. The purpose of this property, when
	                            communicated with a reference is for anyone to validate
	                            later whether the reference still resolved to the same
	                            data that the reference resolved to when the encapsulated
	                            data value with reference was created.
	                        .
	 */
	@XmlAttribute(name = "integrityCheck")
	public java.lang.String integrityCheck;
	/**
	 *                       Specifies the algorithm used to
	                            compute the                      integrityCheck value.
	                        .
	 */
	@XmlAttribute(name = "integrityCheckAlgorithm")
	public net.ihe.gazelle.medication.IntegrityCheckAlgorithm integrityCheckAlgorithm;
	/**
	 *                       For character based information the
	                            language property                      specifies the human language of
	                            the text.                   .
	 */
	@XmlAttribute(name = "language")
	public String language;
	/**
	 *                       Identifies the type of the
	                            encapsulated data and                      identifies a method to
	                            interpret or render the data.                   .
	 */
	@XmlAttribute(name = "mediaType")
	public String mediaType;
	
	/**
	 * An attribute containing marshalled element node
	 */
	@XmlTransient
	private org.w3c.dom.Node _xmlNodePresentation;
	
	
	/**
	 * Return reference.
	 * @return reference
	 */
	public net.ihe.gazelle.medication.TEL getReference() {
		net.ihe.gazelle.medication.TEL reference_el = null;
		
	    return reference_el;
	}
	
	
	
	/**
	 * Return thumbnail.
	 * @return thumbnail
	 */
	public net.ihe.gazelle.medication.Thumbnail getThumbnail() {
		net.ihe.gazelle.medication.Thumbnail thumbnail_el = null;
		
	    return thumbnail_el;
	}
	
	
	
	/**
	 * Return compression.
	 * @return compression :                       Indicates whether the raw byte data
	                            is compressed,                      and what compression algorithm was
	                            used.                                         Indicates whether the raw byte data
	                            is compressed,                      and what compression algorithm was
	                            used.                                         Indicates whether the raw byte data
	                            is compressed,                      and what compression algorithm was
	                            used.                                         Indicates whether the raw byte data
	                            is compressed,                      and what compression algorithm was
	                            used.                                         Indicates whether the raw byte data
	                            is compressed,                      and what compression algorithm was
	                            used.                                         Indicates whether the raw byte data
	                            is compressed,                      and what compression algorithm was
	                            used.                                         Indicates whether the raw byte data
	                            is compressed,                      and what compression algorithm was
	                            used.                   
	 */
	public net.ihe.gazelle.medication.CompressionAlgorithm getCompression() {
	    return compression;
	}
	
	/**
	 * Set a value to attribute compression.
	 * @param compression :                       Indicates whether the raw byte data
	                            is compressed,                      and what compression algorithm was
	                            used.                                         Indicates whether the raw byte data
	                            is compressed,                      and what compression algorithm was
	                            used.                                         Indicates whether the raw byte data
	                            is compressed,                      and what compression algorithm was
	                            used.                                         Indicates whether the raw byte data
	                            is compressed,                      and what compression algorithm was
	                            used.                                         Indicates whether the raw byte data
	                            is compressed,                      and what compression algorithm was
	                            used.                                         Indicates whether the raw byte data
	                            is compressed,                      and what compression algorithm was
	                            used.                                         Indicates whether the raw byte data
	                            is compressed,                      and what compression algorithm was
	                            used.                   .
	 */
	public void setCompression(net.ihe.gazelle.medication.CompressionAlgorithm compression) {
	    this.compression = compression;
	}
	
	
	
	
	/**
	 * Return integrityCheck.
	 * @return integrityCheck :                       The integrity check is a short
	                            binary value representing                      a cryptographically
	                            strong checksum that is calculated                      over the binary
	                            data. The purpose of this property, when
	                            communicated with a reference is for anyone to validate
	                            later whether the reference still resolved to the same
	                            data that the reference resolved to when the encapsulated
	                            data value with reference was created.
	                                              The integrity check is a short
	                            binary value representing                      a cryptographically
	                            strong checksum that is calculated                      over the binary
	                            data. The purpose of this property, when
	                            communicated with a reference is for anyone to validate
	                            later whether the reference still resolved to the same
	                            data that the reference resolved to when the encapsulated
	                            data value with reference was created.
	                                              The integrity check is a short
	                            binary value representing                      a cryptographically
	                            strong checksum that is calculated                      over the binary
	                            data. The purpose of this property, when
	                            communicated with a reference is for anyone to validate
	                            later whether the reference still resolved to the same
	                            data that the reference resolved to when the encapsulated
	                            data value with reference was created.
	                                              The integrity check is a short
	                            binary value representing                      a cryptographically
	                            strong checksum that is calculated                      over the binary
	                            data. The purpose of this property, when
	                            communicated with a reference is for anyone to validate
	                            later whether the reference still resolved to the same
	                            data that the reference resolved to when the encapsulated
	                            data value with reference was created.
	                                              The integrity check is a short
	                            binary value representing                      a cryptographically
	                            strong checksum that is calculated                      over the binary
	                            data. The purpose of this property, when
	                            communicated with a reference is for anyone to validate
	                            later whether the reference still resolved to the same
	                            data that the reference resolved to when the encapsulated
	                            data value with reference was created.
	                                              The integrity check is a short
	                            binary value representing                      a cryptographically
	                            strong checksum that is calculated                      over the binary
	                            data. The purpose of this property, when
	                            communicated with a reference is for anyone to validate
	                            later whether the reference still resolved to the same
	                            data that the reference resolved to when the encapsulated
	                            data value with reference was created.
	                                              The integrity check is a short
	                            binary value representing                      a cryptographically
	                            strong checksum that is calculated                      over the binary
	                            data. The purpose of this property, when
	                            communicated with a reference is for anyone to validate
	                            later whether the reference still resolved to the same
	                            data that the reference resolved to when the encapsulated
	                            data value with reference was created.
	                        
	 */
	public java.lang.String getIntegrityCheck() {
	    return integrityCheck;
	}
	
	/**
	 * Set a value to attribute integrityCheck.
	 * @param integrityCheck :                       The integrity check is a short
	                            binary value representing                      a cryptographically
	                            strong checksum that is calculated                      over the binary
	                            data. The purpose of this property, when
	                            communicated with a reference is for anyone to validate
	                            later whether the reference still resolved to the same
	                            data that the reference resolved to when the encapsulated
	                            data value with reference was created.
	                                              The integrity check is a short
	                            binary value representing                      a cryptographically
	                            strong checksum that is calculated                      over the binary
	                            data. The purpose of this property, when
	                            communicated with a reference is for anyone to validate
	                            later whether the reference still resolved to the same
	                            data that the reference resolved to when the encapsulated
	                            data value with reference was created.
	                                              The integrity check is a short
	                            binary value representing                      a cryptographically
	                            strong checksum that is calculated                      over the binary
	                            data. The purpose of this property, when
	                            communicated with a reference is for anyone to validate
	                            later whether the reference still resolved to the same
	                            data that the reference resolved to when the encapsulated
	                            data value with reference was created.
	                                              The integrity check is a short
	                            binary value representing                      a cryptographically
	                            strong checksum that is calculated                      over the binary
	                            data. The purpose of this property, when
	                            communicated with a reference is for anyone to validate
	                            later whether the reference still resolved to the same
	                            data that the reference resolved to when the encapsulated
	                            data value with reference was created.
	                                              The integrity check is a short
	                            binary value representing                      a cryptographically
	                            strong checksum that is calculated                      over the binary
	                            data. The purpose of this property, when
	                            communicated with a reference is for anyone to validate
	                            later whether the reference still resolved to the same
	                            data that the reference resolved to when the encapsulated
	                            data value with reference was created.
	                                              The integrity check is a short
	                            binary value representing                      a cryptographically
	                            strong checksum that is calculated                      over the binary
	                            data. The purpose of this property, when
	                            communicated with a reference is for anyone to validate
	                            later whether the reference still resolved to the same
	                            data that the reference resolved to when the encapsulated
	                            data value with reference was created.
	                                              The integrity check is a short
	                            binary value representing                      a cryptographically
	                            strong checksum that is calculated                      over the binary
	                            data. The purpose of this property, when
	                            communicated with a reference is for anyone to validate
	                            later whether the reference still resolved to the same
	                            data that the reference resolved to when the encapsulated
	                            data value with reference was created.
	                        .
	 */
	public void setIntegrityCheck(java.lang.String integrityCheck) {
	    this.integrityCheck = integrityCheck;
	}
	
	
	
	
	/**
	 * Return integrityCheckAlgorithm.
	 * @return integrityCheckAlgorithm :                       Specifies the algorithm used to
	                            compute the                      integrityCheck value.
	                                              Specifies the algorithm used to
	                            compute the                      integrityCheck value.
	                                              Specifies the algorithm used to
	                            compute the                      integrityCheck value.
	                                              Specifies the algorithm used to
	                            compute the                      integrityCheck value.
	                                              Specifies the algorithm used to
	                            compute the                      integrityCheck value.
	                                              Specifies the algorithm used to
	                            compute the                      integrityCheck value.
	                                              Specifies the algorithm used to
	                            compute the                      integrityCheck value.
	                        
	 */
	public net.ihe.gazelle.medication.IntegrityCheckAlgorithm getIntegrityCheckAlgorithm() {
	    return integrityCheckAlgorithm;
	}
	
	/**
	 * Set a value to attribute integrityCheckAlgorithm.
	 * @param integrityCheckAlgorithm :                       Specifies the algorithm used to
	                            compute the                      integrityCheck value.
	                                              Specifies the algorithm used to
	                            compute the                      integrityCheck value.
	                                              Specifies the algorithm used to
	                            compute the                      integrityCheck value.
	                                              Specifies the algorithm used to
	                            compute the                      integrityCheck value.
	                                              Specifies the algorithm used to
	                            compute the                      integrityCheck value.
	                                              Specifies the algorithm used to
	                            compute the                      integrityCheck value.
	                                              Specifies the algorithm used to
	                            compute the                      integrityCheck value.
	                        .
	 */
	public void setIntegrityCheckAlgorithm(net.ihe.gazelle.medication.IntegrityCheckAlgorithm integrityCheckAlgorithm) {
	    this.integrityCheckAlgorithm = integrityCheckAlgorithm;
	}
	
	
	
	
	/**
	 * Return language.
	 * @return language :                       For character based information the
	                            language property                      specifies the human language of
	                            the text.                                         For character based information the
	                            language property                      specifies the human language of
	                            the text.                                         For character based information the
	                            language property                      specifies the human language of
	                            the text.                                         For character based information the
	                            language property                      specifies the human language of
	                            the text.                                         For character based information the
	                            language property                      specifies the human language of
	                            the text.                                         For character based information the
	                            language property                      specifies the human language of
	                            the text.                                         For character based information the
	                            language property                      specifies the human language of
	                            the text.                   
	 */
	public String getLanguage() {
	    return language;
	}
	
	/**
	 * Set a value to attribute language.
	 * @param language :                       For character based information the
	                            language property                      specifies the human language of
	                            the text.                                         For character based information the
	                            language property                      specifies the human language of
	                            the text.                                         For character based information the
	                            language property                      specifies the human language of
	                            the text.                                         For character based information the
	                            language property                      specifies the human language of
	                            the text.                                         For character based information the
	                            language property                      specifies the human language of
	                            the text.                                         For character based information the
	                            language property                      specifies the human language of
	                            the text.                                         For character based information the
	                            language property                      specifies the human language of
	                            the text.                   .
	 */
	public void setLanguage(String language) {
	    this.language = language;
	}
	
	
	
	
	/**
	 * Return mediaType.
	 * @return mediaType :                       Identifies the type of the
	                            encapsulated data and                      identifies a method to
	                            interpret or render the data.                                         Identifies the type of the
	                            encapsulated data and                      identifies a method to
	                            interpret or render the data.                                         Identifies the type of the
	                            encapsulated data and                      identifies a method to
	                            interpret or render the data.                                         Identifies the type of the
	                            encapsulated data and                      identifies a method to
	                            interpret or render the data.                                         Identifies the type of the
	                            encapsulated data and                      identifies a method to
	                            interpret or render the data.                                         Identifies the type of the
	                            encapsulated data and                      identifies a method to
	                            interpret or render the data.                                         Identifies the type of the
	                            encapsulated data and                      identifies a method to
	                            interpret or render the data.                   
	 */
	public String getMediaType() {
	    return mediaType;
	}
	
	/**
	 * Set a value to attribute mediaType.
	 * @param mediaType :                       Identifies the type of the
	                            encapsulated data and                      identifies a method to
	                            interpret or render the data.                                         Identifies the type of the
	                            encapsulated data and                      identifies a method to
	                            interpret or render the data.                                         Identifies the type of the
	                            encapsulated data and                      identifies a method to
	                            interpret or render the data.                                         Identifies the type of the
	                            encapsulated data and                      identifies a method to
	                            interpret or render the data.                                         Identifies the type of the
	                            encapsulated data and                      identifies a method to
	                            interpret or render the data.                                         Identifies the type of the
	                            encapsulated data and                      identifies a method to
	                            interpret or render the data.                                         Identifies the type of the
	                            encapsulated data and                      identifies a method to
	                            interpret or render the data.                   .
	 */
	public void setMediaType(String mediaType) {
	    this.mediaType = mediaType;
	}
	
	
	
	
	
	public Node get_xmlNodePresentation() {
		if (_xmlNodePresentation == null){
				JAXBContext jc;
				DocumentBuilderFactory dbf = DocumentBuilderFactory.newInstance();
				dbf.setNamespaceAware(true);
				DocumentBuilder db = null;
				Document doc = null;
				try {
					db = dbf.newDocumentBuilder();
					doc = db.newDocument();
				} catch (ParserConfigurationException e1) {}
				try {
					jc = JAXBContext.newInstance("net.ihe.gazelle.medication");
					Marshaller m = jc.createMarshaller();
					m.marshal(this, doc);
					_xmlNodePresentation = doc.getElementsByTagNameNS("urn:epsos-org:ep:medication", "desc").item(0);
				} catch (JAXBException e) {
					try{
						db = dbf.newDocumentBuilder();
						_xmlNodePresentation = db.newDocument();
					}
					catch(Exception ee){}
				}
			}
			return _xmlNodePresentation;
	}
	
	public void set_xmlNodePresentation(Node _xmlNodePresentation) {
		this._xmlNodePresentation = _xmlNodePresentation;
	}
	
	
	

	
	/**
     * validate by a module of validation
     * 
     */
   public static void validateByModule(ED eD, String location, ConstraintValidatorModule cvm, List<net.ihe.gazelle.validation.Notification> diagnostic){
   		if (eD != null){
   			net.ihe.gazelle.medication.BIN1.validateByModule(eD, location, cvm, diagnostic);
			net.ihe.gazelle.medication.TEL.validateByModule(eD.getReference(), location + "/reference", cvm, diagnostic);
			net.ihe.gazelle.medication.Thumbnail.validateByModule(eD.getThumbnail(), location + "/thumbnail", cvm, diagnostic);
    	}
    }

}